/*
 * Copyright (c) 2006 U1 Consulting Group, Inc. All Rights Reserved. All Rights
 * Reserved.
 */
import com.u1.client.*;
import com.u1.zclient.VirtualClient;
import com.u1.zclient.VirtualClientParams;
import com.u1.zclient.IExceptionHandler;
import com.u1.zclient.VirtualClient;
import com.u1.zclient.Label;

public class CreateQ {

        public static void main(String[] args) {
                try {
                        if(args.length != 4) {
                                System.out.println("usage: java CreateQ <brokerhost> <user> <password> <QueueName>");
                                System.exit(1);
                        }
                        
                        String broker = args[0];
                        String user = args[1];
                        String password = args[2];
                        String queueName = args[3];
                        
                        Credentials creds = new Credentials(user, password);
                        com.u1.jms.Queue queue = new com.u1.jms.Queue(queueName);
                        Connection con = new Connection("myAppID_" + ((new java.util.Random()).nextInt()), 
                                        creds, new MessageHandler());
                        con.connect(broker);
                        com.u1.zclient.Connection zconnection = com.u1.zclient.Connection.toZClient(con);
                        VirtualClientParams vcp = new VirtualClientParams();
                        vcp.setQueue(true);
                        vcp.setExceptionHandler(eh);
                        //VirtualClient vc = zconnection.createVirtualClient("Queue", queue.getMangledSubject(), eh, true);
                        VirtualClient vc = zconnection.createVirtualClient("Queue", queue.getMangledSubject(), vcp);

                        Label label = new Label();
                        label.setGuaranteed(true, false);
                        vc.subscribe(queue.getSubject(), label);
                        vc.cleanUp();

                        System.out.println("CreateQ createVirtualClient " + queue.getMangledSubject() + 
                                        (vc == null ? " ------- FAILS ---------- " : " ------- SUCCEEDS ---------- "));
                        con.disconnect(true);
                        con.cleanUp();
                        System.exit(0);
                        
                } catch(Exception e) {
                        System.out.println(e.getMessage());
                        e.printStackTrace();
                        System.exit(1);
                }
        }

        static IExceptionHandler eh = new IExceptionHandler() {
                
                public void handleException(EGeneralException e)
                {
                        System.out.println("Queue create/delete error: " + e.getMessage());
                }
        };
}
