#!/bin/bash

if [ -z $MULE_HOME ]; then
  if [ -d ../mule-1.4.3 ]; then
    curdir=`pwd`
    parentdir=`dirname $curdir`
    MULE_HOME=$parentdir/mule-1.4.3
    export MULE_HOME
  fi
fi

if [ ! -d $MULE_HOME ]; then
  echo "MULE_HOME must be set to the Mule Home Directory before running this program.  Exiting."
  exit 1
fi

#
# Set the classpath

JMS_JAR=$MULE_HOME/lib/user/jms.jar
if [ ! -f $JMS_JAR ]; then
  echo "jms.jar must be copied to $JMS_JAR before running this program.  Exiting."
  exit 1
fi

CLIENT_JAR=`ls $MULE_HOME/lib/user/ambrosia-client-*.jar`
if [ ! -f $CLIENT_JAR ]; then
  echo "The Ambrosia client jar (ambrosia-client-.jar) must be copied to $MULE_HOME/lib/user/ before running this program.  Exiting."
  exit 1
fi

export CLASSPATH=".:$JMS_JAR:$CLIENT_JAR"
echo "CLASSPATH :  $CLASSPATH"

echo "Creating Queues 'muleInQueue' and 'muleOutQueue' that are used by this example"
java CreateQ localhost:8001 Administrator Administrator muleInQueue
java CreateQ localhost:8001 Administrator Administrator muleOutQueue

