
'## GLOBAL VARIABLES

NL = vbNewLine

Set WshShell = WScript.CreateObject("WScript.Shell")

Set Fso = CreateObject("Scripting.FileSystemObject")

Set WshSysEnv = WshShell.Environment("Process")

basedir=""
user = WshSysEnv("USERNAME")
mode = ""
MULE_HOME = WshSysEnv("MULE_HOME")
CLASSPATH = ""
CLIENT_JAR = ""
JMS_JAR = ""
JAVA_HOME = WshSysEnv("JAVA_HOME")
JAVA = ""
JAVAC = ""

'# Double-quote string
q = """"

'######################################################

Sub echo(str)
   WScript.Echo str
End Sub

'######################################################

Sub print_help() 
   echo ""
   echo "Usage: runAmbMule.bat [OPTIONS]"
   echo "      -?, -h, --help	Display this help and exit."
   echo "      --durable	Run the test with Durable Subscriptions"
   echo "      -d		  (same as --durable)" 
   echo "      --reliable	Run the test with Reliable Subscriptions"
   echo "      -r		  (same as --reliable)"
   echo "      --queue		Run the test with Queues"
   echo "      -q		  (same as --queue)"
   echo ""
End Sub

'######################################################

Sub print_help_exit() 

  print_help
  WScript.Quit 1

End Sub
'######################################################

Sub parse_arguments() 

   Dim paramName, paramValue, param

   if WScript.Arguments.Count = 0 Then
      echo "Missing argument"
      print_help_exit
   end if

   for each param in WScript.Arguments
      paramAry = Split( param, "=", 2 )

      paramName = paramAry(0)
      if UBound( paramAry ) = 0 then
         paramValue = ""
      else
         paramValue = paramAry(1)
      end if

      select case paramAry(0)
         case "-h"           print_help_exit
         case "-?"           print_help_exit
         case "-help"        print_help_exit
         case "--help"       print_help_exit
         case "--durable"    mode = "durable"
         case "-d"     	     mode = "durable"
         case "--reliable"   mode = "reliable"
         case "-r"	     mode = "reliable"
         case "--queue"      mode = "queue"
         case "-q"           mode = "queue"
         case else           echo "ERROR:  Unknown parameter: " & param
		             print_help_exit
      end select
   next

End Sub

'######################################################

Sub set_directory() 

   '# Double-quotes in the path cause problems, so remove them.
   JAVA_HOME = Replace( JAVA_HOME, """", "" )
   echo "JAVA_HOME : " & JAVA_HOME
   
   if JAVA_HOME = "" then
     echo "JAVA_HOME must be set to run the example."
     WScript.quit 1
   end if
   
   if NOT fso.FolderExists(JAVA_HOME) then
     echo "JAVA_HOME must point to an actual directory to run the example."
     WScript.quit 1
   end if
   
   JAVA = JAVA_HOME & "\bin\java.exe"
   if NOT fso.FileExists(JAVA) then
        echo "The file: " & JAVA & " must exist to run the example."
        WScript.quit 1
   end if
   
   '# Set MULE_HOME if it isn't set already
   MULE_HOME = Replace( MULE_HOME, """", "" )
   if MULE_HOME = "" then
     if fso.FolderExists("..\mule-1.4.3") then
       MULE_HOME = FSO.GetFolder("..\mule-1.4.3").path
       curdir = FSO.GetFolder(".").path
       parentdir = FSO.GetFolder("..").path
     end if
   end if

   if NOT fso.FolderExists(MULE_HOME) then
     if MULE_HOME = "" then
       echo "MULE_HOME must be set to the Mule Home Directory before running this program.  Exiting."
     else
       echo "MULE_HOME is set to a directory that does not exist, MULE_HOME is: " & MULE_HOME & ", Exiting."
     end if
     WScript.Quit 1
   end if
   
   '#echo "curdir = " & curdir
   '# echo "parentdir = " & parentdir
   echo "MULE_HOME = " & MULE_HOME

End Sub

'######################################################

Sub get_ambrosia_client_jar()

  Set libdir = fso.GetFolder (MULE_HOME & "\lib\user")
  Set files = libdir.Files

  Set rx = New RegExp

  rx.Pattern = "ambrosia-client.*.jar"
  rx.IgnoreCase = true

  Dim source()
  idx = -1
  For Each f in files
    '# echo "checking pattern for file: " & f.Name
    if rx.Test (f.Name) then
      'echo "## found match, file: " & f.Name & ", path: " & f.Path
      idx = idx + 1
      ReDim preserve source(idx)
      source(idx) = f.Path
    end if
  Next

  if idx > 0 then
    echo "Multiple ambrosia client jars found in " & MULE_HOME & "\lib\user"
    WScript.Quit 1
  end if
  
  if idx < 0 then
    echo "No ambrosia client jar found in " & MULE_HOME & "\lib\user"
    WScript.Quit 1
  end if
  
  CLIENT_JAR = source(0)
  echo "Found client jar: " & CLIENT_JAR
  
End Sub

'######################################################

Sub set_classpath()

  JMS_JAR = MULE_HOME & "\lib\user\jms.jar"

  if NOT fso.FileExists(JMS_JAR) then
    echo "jms.jar must be copied to " & JMS_JAR & " before running this program.  Exiting."
    WScript.quit 1
  end if

  get_ambrosia_client_jar

  if NOT fso.FileExists(CLIENT_JAR) then
    echo "The Ambrosia client jar (ambrosia-client-*.jar) must be copied to " & MULE_HOME & "\lib\user\ before running this program.  Exiting."
    WScript.quit 1
  end if

  CLASSPATH = q & ".;" & JMS_JAR & ";" & CLIENT_JAR & q

  echo "CLASSPATH = " & CLASSPATH
  WshSysEnv("CLASSPATH") = CLASSPATH

End Sub

'######################################################

Sub run_java()

  '#echo "Compiling the AmbMule example from the example package"
  
  q = """"
  jc = q & JAVA_HOME & "\bin\javac.exe" & q & " -cp " & CLASSPATH 
  java = q & JAVA & q & " -cp " & CLASSPATH 

  
  '#echo "%comspec% /c " & jc & " AmbMule.java"
  '# WshShell.Exec( "%comspec% /c " & jc & " -cp " & CLASSPATH & " AmbMule.java" )

  opts=""

  echo ""
  echo "Run the AmbMule example Ambrosia JMS client, with mode: " & mode

  brokerLogin = " ""localhost:8021, localhost:8011"" Administrator Administrator"
  
  params = " AmbMule --" & mode & brokerLogin
  
  javaCmd = "%comspec% /c " & q & java
  
  if mode = "durable" then
    cmd =  javaCmd & params & " pool-2" & q
    WshShell.Run cmd, 4, FALSE
  end if

  if mode = "reliable" then   
    cmd = javaCmd & params & q
    echo "cmd = " & cmd
    WshShell.Run cmd, 4, FALSE
  end if

  if mode = "queue" then
    uidpwd = "MT1"
    echo "  INFO: Setting the user id to use for Queues to: " & uidpwd
    opts = opts & " -Dcom.u1.naming.uid=" & uidpwd
    opts = opts & " -Dcom.u1.naming.password=" & uidpwd
    cmd = javaCmd & opts & params & q
    WshShell.Run cmd, 4, FALSE
  end if

End Sub

'######################################################

'########
'# MAIN #
'########

'#echo "### Starting main ..."

parse_arguments

set_directory

set_classpath

run_java

echo "### DONE."
